config/routes.rb
Rails.application.routes.draw do
  root to: 'games#ui'
  post "/hit", to: "games#save_hit"

  resources :games, only: [:create] do
    collection do
      get :current
      post :finish
    end
  end

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/ball_throw.rb
class BallThrow < ApplicationRecord
  belongs_to :game
  belongs_to :player
end

app/models/game.rb
class Game < ApplicationRecord

  has_many :players
  has_many :ball_throws

  accepts_nested_attributes_for :players

  attribute :player_names, :text

  validates :player_names, presence: true, on: :create

  def initialize(*args)
    super(*args)

    if new_record?
      if self[:start_at].blank?
        write_attribute(:start_at, Time.now)
      end
    end
  end

  def player_names=(values)
    names = values.split("\n").select(&:present?)
    self.players_attributes = names.map do |name|
      {name: name.strip }
    end

    @player_names = names.present? ? values : ""
  end

  def player_names
    @player_names
  end

end

app/models/player.rb
class Player < ApplicationRecord

  has_many :ball_throws

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/games_controller.rb
class GamesController < ApplicationController
  skip_before_action :verify_authenticity_token, only: :save_hit

  def ui
    @current_game = current_game

    if @current_game
      @current_turn = GameService.new(@current_game).current_turn
    else
      @last_gname = Game.where(complete: true).last
    end
  end

  def current
    @current_game = current_game

    if @current_game
      service = GameService.new(@current_game)
      current_turn = service.current_turn

      players = {}
      @current_game.players.map do |player|
        players[player.id] = {
          name:   player.name,
          score:  player.score.to_i,
          winner: !!player.winner
        }
      end

      throw_mtx = {}
      service.get_throw_mtx.each do |player_id, frames_hash|
        throw_mtx[player_id] ||= {}
        scores = service.player_scores(player_id)
        frames_hash.each do |fn, hits|
          throw_mtx[player_id][fn] = {
            hits: hits.map(&:pins),
            score: scores[fn],
            is_strike: !!hits.first.try(:is_strike),
            is_spare: !!hits.second.try(:is_spare)
          }
        end
      end

      render json: {
        game_id: @current_game.id,
        start_at: @current_game.start_at,
        complete: @current_game.complete,
        players: players,
        frames: throw_mtx,
        current_turn: {
          frame: current_turn[:frame],
          player_id: current_turn[:player].try(:id),
          player_name: current_turn[:player].try(:name),
          max_pins: current_turn[:max_pins]
        },
      }
    else
      render json: nil, status: 404
    end
  end

  def create
    if current_game.present?
      render json: {success: false, messages: ["game already started"]}, status: 422
      return
    end

    @game = Game.new(game_params)

    if @game.save
      render json: {success: true, game_id: @game.id}, status: 201
    else
      render json: {success: false, messages: @game.errors.full_messages}, status: 422
    end
  end

  def finish
    if current_game
      current_game.update(complete: true)
      render json: {success: true, game_id: current_game.id}, status: 202
    else
      render json: {success: false, messages: ["Game not started"]}, status: 422
    end
  end

  def save_hit
    if params[:score].blank?
      render json: {success: false, messages: ["Score parameter is missing"]}, status: 422
      return
    end

    unless current_game
      render json: {success: false, messages: ["Game not started"]}, status: 422
      return
    end

    GameService.new(current_game).save_hit(params[:score].to_i)

    render json: {success: true}, status: 202
  end

  private

  def current_game
    @current_game ||= Game.where(complete: false).first
  end

  def game_params
    params.require(:game).permit(:player_names)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/form_helper.rb
module FormHelper

  def error_messages(resource)
    return "" if resource.errors.empty?

    error_messages_element(resource.errors.full_messages.uniq, resource.class.model_name.human.downcase)
  end

  def error_messages_element(errors, resource_name)
    return "" if errors.empty?

    messages = errors.map { |msg| content_tag(:li, msg) }.join
    sentence = I18n.t("errors.messages.not_saved", count: errors.size, resource: resource_name)

    html = <<-HTML
    <div id="error_explanation" class="alert alert-danger">
      <h4>#{sentence}</h4>
      <ul>#{messages}</ul>
    </div>
    HTML

    html.html_safe
  end

end

app/views/games/_game_table.haml
- current_turn ||= nil

%table.table.is-bordered.is-striped.game-table
  %thead
    %tr
      %th Name
      - 1.upto(10) do |i|
        %th= i
      %th Total Score
  %tbody
    - all_throws = game.ball_throws.to_a
    - game.players.each do |player|
      - scores = GameService.new(game).player_scores(player.id)
      %tr
        %td
          %strong= player.name
          - if player.winner
            = "🏆"
        - 1.upto(10) do |frame_no|
          - is_current = current_turn && current_turn[:player] == player && current_turn[:frame] == frame_no
          %td{class: is_current ? "current-frame" : ''}
            - throws = all_throws.select {|bt| bt.player_id == player.id && bt.frame == frame_no }
            = throws.map(&:pins).join(" | ")
            - if scores[frame_no]
              %sup= scores[frame_no]
        %td= scores.values.sum

app/views/games/ui.haml
- if @current_game

  = render "game_table", game: @current_game, current_turn: @current_turn

  = form_tag(:hit, method: "POST") do
    .field.has-addons
      .control
        - max = @current_turn[:max_pins]
        %input.input{name: "score", type: "number", placeholder: "Score", value: (0..max).to_a.sample, max: max, nim: 0}
      .control
        %button.button.is-primary 🎳

  %br
  = link_to "Finish Game", finish_games_path, data: {method: "post"}, class: "button"

- else
  - if @last_gname
    %strong Last Game
    = render "game_table", game: @last_gname

  .box
    = form_for @game || Game.new do |f|
      = error_messages(f.object)

      .field
        = f.label :player_names, "Player Names", class: 'label'
        .control
          = f.text_area :player_names, class: 'textarea', placeholder: "Felix\nAnna\nMaxime\nOle"

      .field
        = f.submit "Start Game", class: 'button is-primary'

app/views/layouts/application.haml
!!!
%html
  %head
    %title BowlingGame
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag    'application', media: 'all'
    = javascript_include_tag 'application'

  %body
    .container{style: "margin-top: 3rem"}
      = yield